
TYPO3.Flow - Bug # 13559

Status: Accepted Priority: Should have
Author: Martin Eisengardt Category: Persistence
Created: 2011-03-02 Assigned To: Karsten Dambekalns
Updated: 2012-11-08 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: ObjectSerializer failes with persistent objects within arrays
Description

If a persistent object is contained in an array property, the serialization failes. It won't detect the object as persistent but will persist it
as if it was a simple data object. This will be broken as soon as the session is resumed/ the object serializer is unserializing this data
stream.

The reason is that persistent object detection is only present in method serializeObjectAsPropertyArray. Method
buildStorageArrayForArrayProperty only contains a small is_object that won't respect the persistence:

if (is_object($value)) {
                $storableArray[$key][self::TYPE] = 'object';
                $storableArray[$key][self::VALUE] = spl_object_hash($value);

                $this->serializeObjectAsPropertyArray($value, FALSE);
            }

Related issues:
related to TYPO3.Flow - Bug # 42715: ObjectSerializer not capable of Collections Resolved 2012-11-06

History
#1 - 2011-10-21 13:20 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#2 - 2012-03-14 13:45 - Christian Müller
- Status changed from New to Needs Feedback
- Has patch set to No

Persistable Objects should best be stored in a Doctrine Collection like the ArrayCollection. Then persistence will persist the objects properly. Do we
still want to fix this somehow?

#3 - 2012-11-08 09:39 - Karsten Dambekalns
- Category set to Persistence
- Status changed from Needs Feedback to Accepted
- Assigned To set to Karsten Dambekalns

Possible without too much hassle.
